#! /usr/bin/perl -w
# expire_numbered_logs.pl - Look through a set of numbered MySQL
# log files and delete those that are more than a week old.

# Usage: expire_numbered_logs.pl logfile ...

use strict;
die "Usage: $0 logfile ...\n" if @ARGV == 0;
my $max_allowed_age = 7;	# max allowed age in days
foreach my $file (@ARGV)	# check each argument
{
	unlink ($file) if -e $file && -M $file >= $max_allowed_age;
}
exit (0);
