/*
 * map mysql_real_escape_string() to mysql_escape_string()
 * if the former isn't available
 */

#if !defined(MYSQL_VERSION_ID) || (MYSQL_VERSION_ID<32314)
#define mysql_real_escape_string(conn,to_str,from_str,len) \
			mysql_escape_string(to_str,from_str,len)
#endif

/* #@ _LOAD_IMAGE_ */
int
load_image (MYSQL *conn, int id, FILE *f)
{
char			query[1024*100], buf[1024*10], *p;
unsigned long	from_len;
int				status;

	sprintf (query,
			"INSERT INTO picture (pict_id,pict_data) VALUES (%d,'",
			id);
	p = query + strlen (query);
	while ((from_len = fread (buf, 1, sizeof (buf), f)) > 0)
	{
		/* don't overrun end of query buffer! */
		if (p + (2*from_len) + 3 > query + sizeof (query))
		{
			print_error (NULL, "image too big");
			return (1);
		}
		p += mysql_real_escape_string (conn, p, buf, from_len);
	}
	*p++ = '\'';
	*p++ = ')';
	status = mysql_real_query (conn, query, (unsigned long) (p - query));
	return (status);
}
/* #@ _LOAD_IMAGE_ */
