#include <mysql.h>

/*
 * map mysql_field_count() to mysql_num_fields()
 * if the former isn't available
 */

/* #@ _MAP_MYSQL_FIELD_COUNT_ */
#if !defined(MYSQL_VERSION_ID) || (MYSQL_VERSION_ID<32224)
#define mysql_field_count mysql_num_fields
#endif
/* #@ _MAP_MYSQL_FIELD_COUNT_ */

/*
 * map mysql_real_escape_string() to mysql_escape_string()
 * if the former isn't available
 */

/* #@ _MAP_MYSQL_REAL_ESCAPE_STRING_ */
#if !defined(MYSQL_VERSION_ID) || (MYSQL_VERSION_ID<32314)
#define mysql_real_escape_string(conn,to_str,from_str,len) \
			mysql_escape_string(to_str,from_str,len)
#endif
/* #@ _MAP_MYSQL_REAL_ESCAPE_STRING_ */

void f (void)
{
MYSQL *conn;
char *to_str;

	(void) mysql_field_count (conn);
	(void) mysql_real_escape_string (conn, to_str, "abc", 3);

}
