/*
 * process a result set, displaying the metadata rather than the data
 */

void
process_result_set (MYSQL *conn, MYSQL_RES *res_set)
{
MYSQL_ROW		row;
MYSQL_FIELD		*field;
unsigned long	*length;
unsigned int	i;

	printf ("   %-12s %-12s %-12s %3s %3s %4s %4s %s\n",
				"name", "table", "default", "len", "max", "type", "dec",
				"not null");
	for (i = 0; i < mysql_num_fields (res_set); i++)
	{
		field = mysql_fetch_field (res_set);
		printf ("%2u %-12s %-12s %-12s %3u %3u %4u %4u %3d\n",
			i,
			field->name,
			field->table ? field->table : "NULL",
			field->def ? field->def : "NULL",
			field->length,
			field->max_length,
			field->type,
			field->decimals,
			IS_NOT_NULL(field->flags)
		);
	}
}
