<?php
#@ _COMMENT_
# sampdb.php - sampdb sample database common functions
#@ _COMMENT_

#@ _SAMPDB_CONNECT_
# Connect to the MySQL server using our top-secret name and password

function sampdb_connect ()
{
	$conn_id = @mysql_connect ("cobra.snake.net", "sampadm", "secret");
	if ($conn_id && mysql_select_db ("sampdb"))
		return ($conn_id);
	return (FALSE);
}
#@ _SAMPDB_CONNECT_

# Put out initial HTML tags for page.  $title and $header, if
# present, are assumed to have any special characters properly
# encoded.

#@ _HTML_BEGIN_
function html_begin ($title, $header)
{
	print ("<html>\n");
	print ("<head>\n");
	if ($title != "")
		print ("<title>$title</title>\n");
	print ("</head>\n");
	print ("<body bgcolor=\"white\">\n");
	if ($header != "")
		print ("<h2>$header</h2>\n");
}
#@ _HTML_BEGIN_

# put out final HTML tags for page.

#@ _HTML_END_
function html_end ()
{
	print ("</body></html>\n");
}
#@ _HTML_END_

# Quote special characters in a data value so that it's safe to insert
# into a SQL query.  The return value *include* any necessary surrounding
# quote, except that an unset value (which represents a NULL value) is
# returned as the word NULL with no quotes.

# Try to use mysql_real_escape_string(), mysql_escape_string(), and
# addslashes(), in that order.  If mysql_real_escape_string() is
# used, no connection identifier argument is used, which means that
# the current connection is assumed.

#@ _QUOTE_VALUE_
function quote_value ($str)
{
	if (!isset ($str))
		return ("NULL");
	if (function_exists ("mysql_real_escape_string"))
		return ("'" . mysql_real_escape_string ($str) . "'");
	if (function_exists ("mysql_escape_string"))
		return ("'" . mysql_escape_string ($str) . "'");
	return ("'" . addslashes ($str) . "'");
}
#@ _QUOTE_VALUE_

# Generate Web form elements.  Arguments that become part of the
# content of the element are automatically HTML-encoded.

# Print hidden field

#@ _HIDDEN_FIELD_
function hidden_field ($name, $value)
{
	printf ("<input type=\"%s\" name=\"%s\" value=\"%s\" />\n",
				"hidden",
				htmlspecialchars ($name),
				htmlspecialchars ($value));
}
#@ _HIDDEN_FIELD_

# Print editable text entry field

#@ _TEXT_FIELD_
function text_field ($name, $value, $size)
{
	printf ("<input type=\"%s\" name=\"%s\" value=\"%s\" size=\"%s\" />\n",
				"text",
				htmlspecialchars ($name),
				htmlspecialchars ($value),
				htmlspecialchars ($size));
}
#@ _TEXT_FIELD_

# Print password entry field

function password_field ($name, $value, $size)
{
	printf ("<input type=\"%s\" name=\"%s\" value=\"%s\" size=\"%s\" />\n",
				"password",
				htmlspecialchars ($name),
				htmlspecialchars ($value),
				htmlspecialchars ($size));
}

# Print radio button.  $checked should be true if the box should be
# selected by default.

#@ _RADIO_BUTTON_
function radio_button ($name, $value, $label, $checked)
{
	printf ("<input type=\"%s\" name=\"%s\" value=\"%s\"%s />%s\n",
				"radio",
				htmlspecialchars ($name),
				htmlspecialchars ($value),
				($checked ? " checked=\"checked\"" : ""),
				htmlspecialchars ($label));
}
#@ _RADIO_BUTTON_

# Print form submission button

#@ _SUBMIT_BUTTON_
function submit_button ($name, $value)
{
	printf ("<input type=\"%s\" name=\"%s\" value=\"%s\" />\n",
				"submit",
				htmlspecialchars ($name),
				htmlspecialchars ($value));
}
#@ _SUBMIT_BUTTON_

# script_param() extracts an input parameter from the script execution
# environment.  It uses the $_GET and $_POST arrays if they are available,
# and the $HTTP_GET_VARS and $HTTP_POST_VARS arrays if they are not.
# If extra backslashes were added due to magic_quotes_gpc being
# enabled, it strips them using the remove_backslashes() function.
# track_vars is assumed to be enabled, but nothing is assumed about
# magic_quotes_gpc, and the function does not require register_globals to
# be enabled. 

# remove_backslashes() takes into account whether the value is a scalar or
# an array.  It is recursive in case you create a form that takes advantage
# of PHP 4's ability to created nested input parameters.

#@ _REMOVE_BACKSLASHES_
function remove_backslashes ($val)
{
	if (!is_array ($val))
		$val = stripslashes ($val);
	else
	{
		reset ($val);
		while (list ($k, $v) = each ($val))
			$val[$k] = remove_backslashes ($v);
	}
	return ($val);
}
#@ _REMOVE_BACKSLASHES_

#@ _SCRIPT_PARAM_
function script_param ($name)
{
global $HTTP_GET_VARS, $HTTP_POST_VARS;

	unset ($val);
	if (isset ($_GET[$name]))
		$val = $_GET[$name];
	else if (isset ($_POST[$name]))
		$val = $_POST[$name];
	else if (isset ($HTTP_GET_VARS[$name]))
		$val = $HTTP_GET_VARS[$name];
	else if (isset ($HTTP_POST_VARS[$name]))
		$val = $HTTP_POST_VARS[$name];
	if (isset ($val) && get_magic_quotes_gpc ())
		$val = remove_backslashes ($val);
	# return @$val rather than $val to prevent "undefined value"
	# messages in case $val is unset and warnings are enabled
	return (@$val);
}
#@ _SCRIPT_PARAM_

# Return the pathname of the current script.  The function tries the
# $_SERVER superglobal array, the $HTTP_SERVER_VARS global array, and
# the $PHP_SELF global variable.  $PHP_SELF is the only variable that
# will be available in older PHP 3 installations, so it's consulted as
# a last resort; unfortunately, to use this variable, it's required
# that the register_globals configuration setting be enabled.

#@ _SCRIPT_NAME_
function script_name ()
{
global $HTTP_SERVER_VARS, $PHP_SELF;

	if (isset ($_SERVER["PHP_SELF"]))
		return ($_SERVER["PHP_SELF"]);
	if (isset ($HTTP_SERVER_VARS["PHP_SELF"]))
		return ($HTTP_SERVER_VARS["PHP_SELF"]);
	return ($PHP_SELF);
}
#@ _SCRIPT_NAME_

?>
