<?php
#@ _OUTLINE_PART_1_
# edit_member.php - Edit Historical League member entries via the Web

include "sampdb.php";

# define action constants
define ("SHOW_INITIAL_PAGE", 0);
define ("DISPLAY_ENTRY", 1);
define ("UPDATE_ENTRY", 2);
#@ _OUTLINE_PART_1_

# display a login form to solicit the member's ID and password

#@ _SOLICIT_MEMBER_ID_
function display_login_page ()
{
	printf ("<form method=\"POST\" action=\"%s?action=%s\">\n",
				script_name (),
				urlencode (DISPLAY_ENTRY));
	print ("Enter your membership ID number and password,\n");
	print ("then select Submit.\n<br /><br />\n");
	print ("<table>\n");
	print ("<tr>");
	print ("<td>Member ID</td><td>");
	text_field ("member_id", "", 10);
	print ("</td></tr>");
	print ("<tr>");
	print ("<td>Password</td><td>");
	password_field ("password", "", 10);
	print ("</td></tr>");
	print ("</table>\n");
	submit_button ("button", "Submit");
	print "</form>\n";
}
#@ _SOLICIT_MEMBER_ID_

# Display a column of a member entry.  $label is the visible label
# displayed to the user.  $row is the array containing the member
# entry.  $col_name is the name of a column in the entry.  $editable
# should be true if the user is allowed to change the column value.
# (The value is displayed as non-editable text otherwise.) $editable
# is optional; if missing, it defaults to true.  Field names are
# constructed using row[col_name] format so that when the form is
# submitted, values can be accessed using a $row array rather than a
# bunch of individual variables.

#@ _DISPLAY_COLUMN_
function display_column ($label, $row, $col_name, $editable = TRUE)
{
	print ("<tr>\n");
	printf ("<td>%s</td>\n", htmlspecialchars ($label));
	print ("<td>");
	if ($editable)	# display as edit field
		text_field ("row[$col_name]", $row[$col_name], 80);
	else			# display as read-only text
		print (htmlspecialchars ($row[$col_name]));
	print ("</td>\n");
	print ("</tr>\n");
}
#@ _DISPLAY_COLUMN_

#@ _CHECK_PASS_
function check_pass ($id, $pass)
{
	$query = sprintf ("SELECT password FROM member_pass WHERE member_id = %s",
						quote_value ($id));
	$result_id = mysql_query ($query);
	if (!$result_id)
		die ("Error reading password table");
	if ($row = mysql_fetch_array ($result_id))
		return ($row["password"] == $pass); # TRUE if password matches
	return (FALSE);							# no record found
}
#@ _CHECK_PASS_

# Determine whether the client supplied the correct password for
# a member entry.  If so, display the entry for editing.

#@ _DISPLAY_ENTRY_
function display_entry ()
{
	# Get script parameters; trim whitespace from ID, but
	# not from password, because password must match exactly.

	$member_id = trim (script_param ("member_id"));
	$password = script_param ("password");

	if (empty ($member_id))
		die ("No member ID was specified");
	if (!preg_match ('/^\d+$/', $member_id))	# must look like integer
		die ("Invalid member ID was specified (must be an integer)");
	if (empty ($password))
		die ("No password was specified");
	if (check_pass ($member_id, $password))	# regular member
		$admin = FALSE;
	else if (check_pass (0, $password))		# administrator
		$admin = TRUE;
	else
		die ("Invalid password");

	$query = sprintf ("
					SELECT
						last_name, first_name, suffix, email, street, city,
						state, zip, phone, interests, member_id, expiration
					FROM member WHERE member_id = %s
					ORDER BY last_name
				", quote_value ($member_id));
	$result_id = mysql_query ($query);
	if (!$result_id)
		die ("Cannot execute query");
	if (mysql_num_rows ($result_id) == 0)
		die ("No user with member_id = $member_id was found");
	if (mysql_num_rows ($result_id) > 1)
		die ("More than one user with member_id = $member_id was found");

	printf ("<form method=\"POST\" action=\"%s?action=%s\">\n",
				script_name (),
				urlencode (UPDATE_ENTRY));
	
	# Add member ID and password as hidden values so that next invocation
	# of script can tell which record the form corresponds to and so that
	# the user need not re-enter the password.

	hidden_field ("member_id", $member_id);
	hidden_field ("password", $password);

	# Read results of query and format for editing

	$row = mysql_fetch_array ($result_id);

	print ("<table>\n");

	# Display member ID as static text

	display_column ("Member ID", $row, "member_id", FALSE);

	# $admin is true if the user provided the administrative password,
	# false otherwise. Administrative users can edit the expiration
	# date, regular users cannot.

	display_column ("Expiration", $row, "expiration", $admin);

	# Display other values as editable text

	display_column ("Last name", $row, "last_name");
	display_column ("First name", $row, "first_name");
	display_column ("Suffix", $row, "suffix");
	display_column ("Email", $row, "email");
	display_column ("Street", $row, "street");
	display_column ("City", $row, "city");
	display_column ("State", $row, "state");
	display_column ("Zip", $row, "zip");
	display_column ("Phone", $row, "phone");
	display_column ("Interests", $row, "interests");

	print ("</table>\n");

	submit_button ("button", "Submit");
	print "</form>\n";

}
#@ _DISPLAY_ENTRY_

#@ _UPDATE_ENTRY_
function update_entry ()
{
	# Get script parameters; trim whitespace from ID, but
	# not from password, because it must match exactly, or
	# from row, because it is an array.

	$member_id = trim (script_param ("member_id"));
	$password = script_param ("password");
	$row = script_param ("row");

	$member_id = trim ($member_id);
	if (empty ($member_id))
		die ("No member ID was specified");
	if (!preg_match ('/^\d+$/', $member_id))	# must look like integer
		die ("Invalid member ID was specified (must be an integer)");
	if (!check_pass ($member_id, $password) && !check_pass (0, $password))
		die ("Invalid password");

	# We'll need a result set to use for assessing nullability of
	# member table columns.  The following query provides one without
	# selecting any rows.  Use the query result to construct an
	# associative array that maps column names to true/false values
	# indicating whether columns allow NULL values.

	$result_id = mysql_query ("SELECT * FROM member WHERE 1 = 0");
	if (!$result_id)
		die ("Cannot query member table");
	$nullable = array ();
	for ($i = 0; $i < mysql_num_fields ($result_id); $i++)
	{
		$fld = mysql_fetch_field ($result_id, $i);
		$nullable[$fld->name] = !$fld->not_null;	# TRUE if nullable
	}
	mysql_free_result ($result_id);

	# Iterate through each field in the form, using the values to
	# construct the UPDATE statement.

	$query = "UPDATE member ";
	$delim = "SET";
	reset ($row);
	while (list ($col_name, $val) = each ($row))
	{
		$query .= "$delim $col_name=";
		$delim = ",";
		# if a form value is empty, update the corresponding column value
		# with NULL if the column is nullable.  This prevents trying to
		# put an empty string into the expiration date column when it
		# should be NULL, for example.
		$val = trim ($val);
		if (empty ($val))
		{
			if ($nullable[$col_name])
				$query .= "NULL";	# enter NULL
			else
				$query .= "''";		# enter empty string
		}
		else
			$query .= quote_value ($val);
	}
	$query .= sprintf (" WHERE member_id = %s", quote_value ($member_id));
	if (mysql_query ($query))
		print ("Member entry was updated successfully.\n");
	else
		print ("Member entry was not updated.\n");
}
#@ _UPDATE_ENTRY_

#@ _OUTLINE_PART_2_
$title = "U.S. Historical League -- Member Editing Form";
html_begin ($title, $title);

sampdb_connect ()
	or die ("Cannot connect to server");

# determine what action to perform (the default if
# none is specified is to present the initial page)

$action = script_param ("action");
if (!isset ($action))
	$action = SHOW_INITIAL_PAGE;

switch ($action)
{
case SHOW_INITIAL_PAGE:		# present initial page
	display_login_page ();
	break;
case DISPLAY_ENTRY:			# display entry for editing
	display_entry ();
	break;
case UPDATE_ENTRY:			# store updated entry in database
	update_entry ();
	break;
default:
	die ("Unknown action code ($action)");
}

html_end ();
#@ _OUTLINE_PART_2_
?>
